//AllAboutCircuits.com
//CezarChirila.com
//Credits to http://www.instructables.com/id/Yet-Another-Daft-Punk-Coffee-TableDisplay/
//Credits to Arduino Starter kit Manual by M.McRoberts

#include <TimerOne.h> 

//Pin connected to Pin 12 of 74HC595 (Latch)
int latchPin = 3;
//Pin connected to Pin 11 of 74HC595 (Clock)
int clockPin = 4;
//Pin connected to Pin 14 of 74HC595 (Data)
int dataPin = 5;

typedef byte Frame[8];
uint8_t *led;
int curFrameIdx;

//time
long previousMillis = 0;
long interval = 100; 

//Put the frames in this file
#include "patterns.h" 

void setup() {
  //set pins to output 
  pinMode(latchPin, OUTPUT);
  pinMode(clockPin, OUTPUT);
  pinMode(dataPin, OUTPUT);
  //This is to set the refresh rate
  Timer1.initialize(2000);
  Timer1.attachInterrupt(screenUpdate);
}

void setFrame(int idx) {
  led = Frames[idx];
} 

void loop() {
  unsigned long currentMillis = millis();
   if(currentMillis - previousMillis > interval) {
         previousMillis = currentMillis;   
         if (++curFrameIdx == FRAMECNT) {
             curFrameIdx = 0;
            }
            // select frame for display
         setFrame(curFrameIdx);

  }
}

void screenUpdate() {

  static uint8_t column = B00000001; //Start point for column scanning
  static byte k = 0;
 //The following bytes are used below to generate the row byte
  static byte factor[8];
  static byte rows[8];
  rows[k] = 0; // Reset the current row byte
  
//This is for generating the row byte
  for(int i=0;i<8;i++){
   
    factor[i] = led[i] & column;
    factor[i] >>= k;
    factor[i] <<= i;
    rows[k] += factor[i];
  }

 
 // Open up the latch ready to receive data
  digitalWrite(latchPin, LOW); 

  //Shift out the data Least significant bit first (to mirror the image) 
  shiftOut(dataPin, clockPin, LSBFIRST, column);
  //Shift out the data most significant bit first (to mirror the image)
  shiftOut(dataPin, clockPin, MSBFIRST, rows[k]);

  
  // Close the latch, sending the data in the registers out to the matrix
  digitalWrite(latchPin, HIGH); 

  if (k < 7) {
    column = column << 1;
    k = k + 1;
  }
  else {
    column = B00000001;
    k = 0;
  }
}  

